﻿Module mdlGraphics
    Public BackBufferBitMap As Bitmap
    Public BackBuffer As System.Drawing.Graphics

    Public BackBufferPlayBitMap As Bitmap
    Public BackBufferPlay As System.Drawing.Graphics

    Public BackBufferStateBitMap As Bitmap
    Public BackBufferState As System.Drawing.Graphics

    Public Sub CreateBackBufferPre()
        'If it is "Nothing" already no reset required
        If Not BackBufferBitMap Is Nothing Then
            'Clear RAM and map it to nothing
            BackBufferBitMap.Dispose()
            BackBuffer.Dispose()
            BackBufferBitMap = Nothing
            BackBuffer = Nothing
        End If
        'Create a Backbuffer against ugly flickering
        BackBufferBitMap = New Bitmap(frmTap.pctDraw.Width, frmTap.pctDraw.Height)
        BackBuffer = Graphics.FromImage(BackBufferBitMap)
    End Sub

    Public Sub CreateBackBuffer()
        'If it is "Nothing" already no reset required
        If Not BackBufferBitMap Is Nothing Then
            'Clear RAM and map it to nothing
            BackBufferBitMap.Dispose()
            BackBuffer.Dispose()
            BackBufferBitMap = Nothing
            BackBuffer = Nothing
        End If
        'Create a Backbuffer against ugly flickering
        BackBufferBitMap = New Bitmap(frmTap.pctDraw.Width, frmTap.pctDraw.Height)
        BackBuffer = Graphics.FromImage(BackBufferBitMap)

        Call CreateBackBufferPlay()
        Call CreateBackBufferState()
    End Sub

    Public Sub CreateBackBufferPlay()
        'If it is "Nothing" already no reset required
        If Not BackBufferPlayBitMap Is Nothing Then
            'Clear RAM and map it to nothing
            BackBufferPlayBitMap.Dispose()
            BackBufferPlay.Dispose()
            BackBufferPlayBitMap = Nothing
            BackBufferPlay = Nothing
        End If
        'Create a Backbuffer against ugly flickering
        BackBufferPlayBitMap = New Bitmap(PlayFieldSize.Width, PlayFieldSize.Height)
        BackBufferPlay = Graphics.FromImage(BackBufferPlayBitMap)
    End Sub

    Public Sub CreateBackBufferState()
        'If it is "Nothing" already no reset required
        If Not BackBufferStateBitMap Is Nothing Then
            'Clear RAM and map it to nothing
            BackBufferStateBitMap.Dispose()
            BackBufferState.Dispose()
            BackBufferStateBitMap = Nothing
            BackBufferState = Nothing
        End If
        'Create a Backbuffer against ugly flickering
        BackBufferStateBitMap = New Bitmap(BackBufferBitMap.Width, BackBufferBitMap.Height - BackBufferPlayBitMap.Height)
        BackBufferState = Graphics.FromImage(BackBufferStateBitMap)
    End Sub

    Public Sub DrawCountDown()
        Dim tempString As String
        Dim tempSize As Size
        For I = 3 To 1 Step -1
            Call BackBufferPlay.Clear(Color.Black)
            tempString = I
            tempSize = BackBufferPlay.MeasureString(tempString, frmTap.Font).ToSize
            Call BackBufferPlay.DrawString(tempString, frmTap.Font, New SolidBrush(Color.White), PlayFieldSize.Width / 2 - tempSize.Width / 2, PlayFieldSize.Height / 2 - tempSize.Height / 2)
            Call DrawToSurface()
            Call System.Threading.Thread.Sleep(1000)
        Next

    End Sub

    Public Sub PreDraw()
        Call PreDrawGame()
        Call PreDrawState()
    End Sub

    Public Sub PreDrawGame()
        Call BackBufferPlay.Clear(Color.Black)
        For I = 0 To 3
            For J = 0 To 3
                If PlayMatrix(J, I) = True Then
                    Call BackBufferPlay.FillEllipse(New SolidBrush(Color.Green), J * ClickFieldSize.Width + ClickFieldSize.Width / 8, I * ClickFieldSize.Height + ClickFieldSize.Height / 8, ClickFieldSize.Width * 3 / 4, ClickFieldSize.Height * 3 / 4)
                Else
                    Call BackBufferPlay.DrawEllipse(New Pen(Color.Green), J * ClickFieldSize.Width + ClickFieldSize.Width / 8, I * ClickFieldSize.Height + ClickFieldSize.Height / 8, ClickFieldSize.Width * 3 / 4, ClickFieldSize.Height * 3 / 4)
                End If
            Next
        Next
    End Sub

    Public Sub PreDrawState()
        Dim tempString As String
        Dim tempSize As Size

        Call BackBufferState.Clear(Color.Black)
        tempString = ClickCount & " taps in " & Math.Round(tempTapTime / 1000, 4) & "s" & " - " & Math.Round((tempTapTime / ClickCount), 0) & "ms per tap" & vbNewLine & _
                        "Fastest tap: " & FastestTap & "ms"

        tempSize = BackBufferState.MeasureString(tempString, frmTap.Font).ToSize
        Call BackBufferState.DrawString(tempString, frmTap.Font, New SolidBrush(Color.White), BackBufferStateBitMap.Width / 2 - tempSize.Width / 2, BackBufferStateBitMap.Height / 2 - tempSize.Height / 2)

    End Sub


    Public Sub DrawToSurface()
        Call BackBuffer.DrawImage(BackBufferPlayBitMap, frmTap.Width / 2 - PlayFieldSize.Width / 2, 0)
        Call BackBuffer.DrawImage(BackBufferStateBitMap, 0, BackBufferPlayBitMap.Height)

        frmTap.pctDraw.Image = BackBufferBitMap
        Call frmTap.pctDraw.Refresh()
    End Sub

    Public Function Ticks2String(ByVal Ticks As Int64) As String
        Dim Ticks2MilliSeconds As Int64 = Int(Ticks / (10000))
        Ticks2String = Math.Round(Ticks2MilliSeconds, 2) & "ms"
    End Function
End Module
